'use client';

import s from './styles.module.scss';
import { Button, Input, PhoneInput } from '@shared/ui';
import { Controller, useForm } from 'react-hook-form';
import { zodResolver } from '@hookform/resolvers/zod';
import { isValidPhoneNumber } from 'libphonenumber-js/min';
import { z } from 'zod';
import { sendFormFn } from '@shared/api/api.service';
import toast from 'react-hot-toast';

type CallbackFormProps = {
  pageName?: string;
};

const FormSchema = z.object({
  name: z
    .string()
    .min(3, { message: 'Поле должно содержать не менее 3-х букв' })
    .regex(/^[A-Za-zА-Яа-яЁё]+(?:[ '-][A-Za-zА-Яа-яЁё]+)*$/, {
      message: 'Поле содержит некорректные символы',
    }),
  phone: z.string().refine(isValidPhoneNumber, 'Некорректный номер телефона'),
});

type TForm = z.infer<typeof FormSchema>;

const defaultValues = {
  name: '',
  phone: '',
};

function CallbackForm({ pageName = 'noname-form' }: CallbackFormProps) {
  const {
    handleSubmit,
    control,
    reset,
    clearErrors,
    formState: { errors },
  } = useForm<TForm>({
    mode: 'onSubmit',
    reValidateMode: 'onBlur',
    resolver: zodResolver(FormSchema),
    defaultValues,
  });

  const onSubmit = async (data: TForm) => {
    const payload = {
      ...data,
      form: pageName,
    };

    try {
      await sendFormFn(payload);
      toast.success('Заявка на консультацию принята');
      reset(defaultValues);
    } catch (e) {
      toast.error('Ошибка при отправке заявки...', {
        duration: 3000,
      });
    }
  };

  return (
    <section className={s.Container}>
      <h3 className={s.Title}>Узнать точную стоимость и срок экспертизы</h3>
      <form className={s.Form} onSubmit={handleSubmit(onSubmit)}>
        <Controller
          control={control}
          name={'name'}
          render={({ field }) => (
            <Input
              {...field}
              placeholder='Ваше имя'
              variant={'ghost'}
              fullWidth
              onChange={(e) => {
                clearErrors('name');
                field.onChange(e);
              }}
              error={errors && errors.name?.message}
            />
          )}
        />
        <Controller
          control={control}
          name={'phone'}
          render={({ field }) => (
            <PhoneInput
              {...field}
              placeholder='+7 999 123-45-67'
              variant={'ghost'}
              fullWidth
              onChange={(e) => {
                clearErrors('phone');
                field.onChange(e);
              }}
              error={errors && errors.phone?.message}
            />
          )}
        />
        <Button variant={'white'} fullWidth>
          Узнать
        </Button>
      </form>
    </section>
  );
}

export { CallbackForm };
